package com.example.dogobjectsfromtextfile

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.widget.*

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val spDogData = findViewById<Spinner>(R.id.spDogData)
        val ivDog = findViewById<ImageView>(R.id.ivDog)
        val tvDogHeight = findViewById<TextView>(R.id.tvDogHeight)
        val tvDogColor = findViewById<TextView>(R.id.tvDogColor)
        val tvDogChar = findViewById<TextView>(R.id.tvDogChar)

        val Breeds = arrayListOf<Dog>()  //bunch of dog objects

        val input_stream = baseContext.resources.openRawResource(R.raw.dog_data)
        // create a BufferedeReader from the input stream in order to read line-by-line
        val buffer = input_stream.bufferedReader()

        val lines = buffer.readLines() // creates a List of strings
        val dogNames: MutableList<String> = ArrayList()

        for(item in lines){
            val tokens = item.split("/")  //break into tokens based on delimiter
            dogNames.add(tokens[0]) // add names to list to use to populate spinner
            val aDog = Dog(tokens[0], tokens[1].toInt(), tokens[2], tokens[3] ) //instantiate a dog
            Breeds.add(aDog)  // add dog to the arraylist of dog objects
        }

        //use array of string to populate a spinner
        val aaDogData = ArrayAdapter(this, android.R.layout.simple_spinner_item, dogNames)
        aaDogData.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item) // The drop down view
        spDogData.adapter = aaDogData

        // when item chosen in spinner display same thing in textview
        spDogData.onItemSelectedListener = object : AdapterView.OnItemSelectedListener {
            override fun onItemSelected(adapterView: AdapterView<*>, view: View, i: Int, l: Long) {
                val tvUserItem = view as TextView
                Toast.makeText(applicationContext, "You chose " + tvUserItem.text.toString(), Toast.LENGTH_SHORT).show()

                var drawable_resource_name = tvUserItem.text.toString().toLowerCase().replace(" ", "_")

                //get the id from the resource name
                val drawable_resouce_id = getResources().getIdentifier(drawable_resource_name,
                    "drawable", getPackageName())
                ivDog.setImageResource(drawable_resouce_id)

                tvDogHeight.text = "Average height: " + Breeds[i].ave_height_inches +" inches"
                tvDogColor.text = "Colors: " + Breeds[i].colors
                tvDogChar.text = "Characteristics: " + Breeds[i].character
            }

            override fun onNothingSelected(adapterView: AdapterView<*>) {}
        }//end onItemSelectedListener
    }//end onCreate
}//end MainActivity class
